// Unity built-in shader source. Copyright (c) 2016 Unity Technologies. MIT license (see license.txt)
// "Legacy Shaders/Transparent/Diffuse"
Shader "XGame/TestCloud" 
{
    Properties 
    {
        _Color ("Main Color", Color) = (1,1,1,1)
        _MainTex ("Base (RGB) Trans (A)", 2D) = "white" {}
        _ScrollY ("Scroll Speed", Range(0, 1)) = 1
    }

    SubShader 
    {
        Tags {"Queue"="Transparent" "IgnoreProjector"="True" "RenderType"="Transparent"}
        LOD 200

        CGPROGRAM
        #pragma surface surf NoLight alpha:fade noforwardadd

        sampler2D _MainTex;
        fixed4 _Color;
        float _ScrollY;

        struct Input 
        {
            float2 uv_MainTex;
        };

        void surf (Input IN, inout SurfaceOutput o) 
        {
            fixed4 c = tex2D(_MainTex, IN.uv_MainTex + float2(0, _ScrollY * _Time.y)) * _Color;
            o.Albedo = c.rgb;
            o.Alpha = c.a;
        }
        //շ̣ΪLighting#pragma sufaceĹշ 
        //lightDir :㵽Դĵλ
        //viewDir  :㵽ĵλ   
        //atten    :յ˥ϵ 
        float4 LightingNoLight(SurfaceOutput s, float3 lightDir,half3 viewDir, half atten) 
        { 
            float4 c ; 
            c.rgb =  s.Albedo;
            c.a = s.Alpha; 
            return c; 
        }
        ENDCG
    }

    Fallback "Legacy Shaders/Transparent/VertexLit"
}
