﻿using FL.Battle.Actions;
using System;
using XGame.Framework.Interfaces;

namespace FL.Battle.Components
{
    /// <summary>
    /// 特效播放参数
    /// VfxComponent.Acquire创建实例
    /// VfxComponent.Recycle回收实例
    /// 默认特效播放结束自动回收
    /// </summary>
    public class VfxArgs : IReference
    {
        public string vfxName;
        /// <summary>
        /// 延迟播放
        /// 单位: 毫秒
        /// </summary>
        public int delay = 0;
        /// <summary>
        /// 播放时长，大于零
        /// 单位: 毫秒
        /// </summary>
        public int duration = 0;
        public EVfxFollowType followType;
        public IAction action;
        public Action onFinish;
        /// <summary>
        /// 通过next实现特效顺序播放
        /// </summary>
        public VfxArgs next;
        void IReference.Clear()
        {
            vfxName = string.Empty;
            delay = 0;
            duration = 0;
            followType = EVfxFollowType.Center;
            action = null;
            onFinish = null;
            next = null;
        }
    }
}
