/// #pkgName FGUI包名
/// #panelName UIPanel名字
/// #UIName = $"{#pkgName}{#panelName}" UIKey名字
/// #PropertyDefineArea 属性定义区域
/// #PropertyAssignArea 属性赋值区域
/// #ComponentType 组件类型
/// #PropertyName 属性名字
/// 该脚本由模板创建，不可编辑
/// created by cb 2024
using FairyGUI;
using XGame.Framework.FGUI;
using XGame.Framework.UI;

namespace FL.FGUI
{
    /// <summary>
    /// 该脚本由模板创建，不可修改，不可编辑
    /// </summary>
    public partial class DragonEggEquipVM : FguiViewModel
    {
        public Controller BtnState { get; private set; }
        public CommonBackGroundNestedView MaskBg { get; private set; }
        public DragonEggEquipItemView WearEquipItem { get; private set; }
        public DragonEggEquipItemView NewEquipItem { get; private set; }
        public GButton SellBtn { get; private set; }
        public GButton WearBtn { get; private set; }
        public GButton DecomposeBtn { get; private set; }

        protected override void BindComponents(GComponent panel, IUIViewAdapter adapter)
        {
            BtnState = panel.GetController("BtnState");
            MaskBg = adapter.CreateNested<CommonBackGroundNestedView>(new FguiNested(panel.GetChild("MaskBg").asCom), true);
            WearEquipItem = adapter.CreateNested<DragonEggEquipItemView>(new FguiNested(panel.GetChild("WearEquipItem").asCom), true);
            NewEquipItem = adapter.CreateNested<DragonEggEquipItemView>(new FguiNested(panel.GetChild("NewEquipItem").asCom), true);
            SellBtn = panel.GetChild("SellBtn") as GButton;
            WearBtn = panel.GetChild("WearBtn") as GButton;
            DecomposeBtn = panel.GetChild("DecomposeBtn") as GButton;

        }
    }
}