/// #pkgName FGUI包名
/// #panelName UIPanel名字
/// #UIName = $"{#pkgName}{#panelName}" UIKey名字
/// #PropertyDefineArea 属性定义区域
/// #PropertyAssignArea 属性赋值区域
/// #ComponentType 组件类型
/// #PropertyName 属性名字
/// 该脚本由模板创建，不可编辑
/// created by cb 2024
using FairyGUI;
using XGame.Framework.FGUI;
using XGame.Framework.UI;

namespace FL.FGUI
{
    /// <summary>
    /// 该脚本由模板创建，不可修改，不可编辑
    /// </summary>
    public partial class DragonEggEquipItemVM : FguiViewModel
    {
        public Controller State { get; private set; }
        public CommonItemBaseView ItemBtn { get; private set; }
        public GTextField NameLabel { get; private set; }
        public DragonEggAttrItemView HpAttrItem { get; private set; }
        public DragonEggAttrItemView AtkAttrItem { get; private set; }
        public DragonEggAttrItemView DefAttrItem { get; private set; }
        public DragonEggAttrItemView SpeedAttrItem { get; private set; }
        public DragonEggAttrItemView SpecialAttrItem1 { get; private set; }
        public DragonEggAttrItemView SpecialAttrItem2 { get; private set; }

        protected override void BindComponents(GComponent panel, IUIViewAdapter adapter)
        {
            State = panel.GetController("state");
            ItemBtn = adapter.CreateNested<CommonItemBaseView>(new FguiNested(panel.GetChild("ItemBtn").asCom), true);
            NameLabel = panel.GetChild("NameLabel") as GTextField;
            HpAttrItem = adapter.CreateNested<DragonEggAttrItemView>(new FguiNested(panel.GetChild("HpAttrItem").asCom), true);
            AtkAttrItem = adapter.CreateNested<DragonEggAttrItemView>(new FguiNested(panel.GetChild("AtkAttrItem").asCom), true);
            DefAttrItem = adapter.CreateNested<DragonEggAttrItemView>(new FguiNested(panel.GetChild("DefAttrItem").asCom), true);
            SpeedAttrItem = adapter.CreateNested<DragonEggAttrItemView>(new FguiNested(panel.GetChild("SpeedAttrItem").asCom), true);
            SpecialAttrItem1 = adapter.CreateNested<DragonEggAttrItemView>(new FguiNested(panel.GetChild("SpecialAttrItem1").asCom), true);
            SpecialAttrItem2 = adapter.CreateNested<DragonEggAttrItemView>(new FguiNested(panel.GetChild("SpecialAttrItem2").asCom), true);

        }
    }
}