/// #pkgName FGUI包名
/// #panelName UIPanel名字
/// #UIName = $"{#pkgName}{#panelName}" UIKey名字
/// #PropertyDefineArea 属性定义区域
/// #PropertyAssignArea 属性赋值区域
/// #ComponentType 组件类型
/// #PropertyName 属性名字
/// 该脚本由模板创建，不可编辑
/// created by cb 2024
using FairyGUI;
using XGame.Framework.FGUI;
using XGame.Framework.UI;

namespace FL.FGUI
{
    /// <summary>
    /// 该脚本由模板创建，不可修改，不可编辑
    /// </summary>
    public partial class PlayerDetailsAttributeVM : FguiViewModel
    {
        public CommonBackGroundNestedView Background { get; private set; }
        public PlayerAttributeListView BaseAttributeList { get; private set; }
        public PlayerAttributeListView BattleAttributeList { get; private set; }
        public PlayerAttributeListView BattleResistanceAttrList { get; private set; }
        public PlayerSpecialAttributeListView SpecialAttributeList { get; private set; }

        protected override void BindComponents(GComponent panel, IUIViewAdapter adapter)
        {
            Background = adapter.CreateNested<CommonBackGroundNestedView>(new FguiNested(panel.GetChild("Background").asCom), true);
            BaseAttributeList = adapter.CreateNested<PlayerAttributeListView>(new FguiNested(panel.GetChild("BaseAttributeList").asCom), true);
            BattleAttributeList = adapter.CreateNested<PlayerAttributeListView>(new FguiNested(panel.GetChild("BattleAttributeList").asCom), true);
            BattleResistanceAttrList = adapter.CreateNested<PlayerAttributeListView>(new FguiNested(panel.GetChild("BattleResistanceAttrList").asCom), true);
            SpecialAttributeList = adapter.CreateNested<PlayerSpecialAttributeListView>(new FguiNested(panel.GetChild("SpecialAttributeList").asCom), true);

        }
    }
}