﻿using System;

namespace XGame.Editor.Build
{
    /// <summary>
    /// 为避免Priority冲突，推荐项目自定义Priority时
    /// 使用BuildCommandPriority已定义好的预留枚举(Pre、Post前缀)或者 +/- N
    /// 如：[BuildCommand((uint)BuildCommandPriority.ExportAssets + 1)]
    /// </summary>
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = false)]
    internal class BuildCommandAttribute : Attribute
    {
        public uint Priority { get; private set; }
        public BuildCommandAttribute(uint priority)
        {
            Priority = priority;
        }
    }
}
