﻿namespace XGame.Framework.Asset
{
    /// <summary>
    /// 资源类型
    /// </summary>
    public enum AssetType
    {
        /// <summary>
        /// 未知类型
        /// </summary>
        Unknown = 0,
        /// <summary>
        /// UnityEngine.Object
        /// </summary>
        UniObject = 1,
        Binary,
        /// <summary>
        /// AssetBundle
        /// </summary>
        AssetBundle,
    }

    /// <summary>
    /// 开始处理任务的状态。
    /// </summary>
    public enum AgentStatus
    {
        /// <summary>
        /// 可以立刻处理完成此任务。
        /// </summary>
        Done,

        /// <summary>
        /// 可以继续处理此任务。
        /// </summary>
        CanResume,

        /// <summary>
        /// 不能继续处理此任务，需等待其它任务执行完成。
        /// </summary>
        HasToWait,

        /// <summary>
        /// 不能继续处理此任务，出现未知错误。
        /// </summary>
        UnknownError,
    }

    public enum LoaderType
    {
        AssetDatabase = 0,
        Resources,
        AssetBundle,
        Binary,
    }

    //public enum AddressableAssetType
    //{
    //    Default = 0,
    //    Resources,
    //}
}

