﻿using System;

namespace XGame.Framework.ThreadScheduler
{
    public static class MainThreadUpdateRegister
    {
        private static Action<int> _update;
        public static event Action<int> update
        {
            add
            {
                _update += value;
            }
            remove
            {
                _update -= value;
            }
        }

        public static void Update(int millisecond)
        {
            _update.SafeInvoke(millisecond);
        }

    }
}
