﻿using UnityEngine;
using XGame.Framework.Interfaces;
namespace XGame.Framework.UI
{
    /// <summary>
    /// 嵌套UI
    /// </summary>
    public interface INestedView : IActiveable
    {
        public Vector3 LocalPosition { get; set; }
        public Vector3 Position { get; set; }
        public Vector3 Rotation { get; set; }
    }
    /// <summary>
    /// 框架用INestedView接口
    /// </summary>
    public interface INestedInternal : INestedView
    {
        /// <summary>
        /// 初始化
        /// </summary>
        /// <param name="context"></param>
        /// <param name="nested"></param>
        /// <param name="isStatic">是否是静态的(其他预制的子节点)</param>
        void Init(UIContext context, IUINested nested, bool isStatic);
        IUINested Nested { get; }
    }
}
